# encoding: utf-8
#
# Redmine - project management software
# Copyright (C) 2006-2013  Jean-Philippe Lang
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

include AvatarHelper
module ProjectsHelper
  def link_to_version(version, options = {})
    return '' unless version && version.is_a?(Version)
    link_to_if version.visible?, format_version_name(version), { :controller => 'versions', :action => 'show', :id => version }, options
  end

  def project_settings_tabs
    tabs = [{:name => 'info', :action => :edit_project, :partial => 'projects/edit', :label => :label_information_plural},
            {:name => 'modules', :action => :select_project_modules, :partial => 'projects/settings/modules', :label => :label_module_plural},
            {:name => 'members', :action => :manage_members, :partial => 'projects/settings/members', :label => :label_member_plural},
            {:name => 'versions', :action => :manage_versions, :partial => 'projects/settings/versions', :label => :label_version_plural},
            {:name => 'categories', :action => :manage_categories, :partial => 'projects/settings/issue_categories', :label => :label_issue_category_plural},
            # {:name => 'wiki', :action => :manage_wiki, :partial => 'projects/settings/wiki', :label => :label_wiki},
            {:name => 'repositories', :action => :manage_repository, :partial => 'projects/settings/repositories', :label => :label_repository_plural},
            #{:name => 'boards', :action => :manage_boards, :partial => 'projects/settings/boards', :label => :label_board_plural},
            {:name => 'activities', :action => :manage_project_activities, :partial => 'projects/settings/activities', :label => :enumeration_activities}
            ]
    tabs.select {|tab| User.current.allowed_to?(tab[:action], @project)}
    
  end
  
  # added bu huang
  def sort_project_enterprise(state, project_type)
    content = ''.html_safe
    case state
    when 0

      content << content_tag('li', link_to(l(:label_sort_by_active), projects_path(:project_sort_type => '1', :project_type => project_type)))
      content << content_tag('li', link_to(l(:label_sort_by_influence), projects_path(:project_sort_type => '2', :project_type => project_type)))
      content << content_tag('li', link_to(l(:label_sort_by_time), projects_path(:project_sort_type => '0', :project_type => project_type), :class=>"selected"), :class=>"selected")
    when 1

      content << content_tag('li', link_to(l(:label_sort_by_active), projects_path(:project_sort_type => '1', :project_type => project_type), :class=>"selected"), :class=>"selected")
      content << content_tag('li', link_to(l(:label_sort_by_influence), projects_path(:project_sort_type => '2', :project_type => project_type)))
      content << content_tag('li', link_to(l(:label_sort_by_time), projects_path(:project_sort_type => '0', :project_type => project_type)))
    when 2
      content << content_tag('li', link_to(l(:label_sort_by_active), projects_path(:project_sort_type => '1', :project_type => project_type)))
      content << content_tag('li', link_to(l(:label_sort_by_influence), projects_path(:project_sort_type => '2', :project_type => project_type), :class=>"selected"), :class=>"selected")
      content << content_tag('li', link_to(l(:label_sort_by_time), projects_path(:project_sort_type => '0', :project_type => project_type)))
    end
    content = content_tag('ul', content)    
    content_tag('div', content, :class => "tabs_enterprise")   
  end
  
   def sort_course(state, project_type, school_id)
    content = ''.html_safe
    case state
    when 0
      content << content_tag('li', link_to(l(:label_sort_by_time), course_path(:project_sort_type => '0', :project_type => project_type), :school_id => school_id, :class=>"selected"), :class=>"selected")
      content << content_tag('li', link_to(l(:label_sort_by_active), course_path(:project_sort_type => '1', :project_type => project_type, :school_id => school_id)))
      # content << content_tag('li', link_to(l(:label_sort_by_influence), course_path(:project_sort_type => '2', :project_type => project_type)))
      content << content_tag('li', link_to(l(:label_sort_by_activity), course_path(:project_sort_type => '3', :project_type => project_type, :school_id => school_id)))

    when 1
      content << content_tag('li', link_to(l(:label_sort_by_time), course_path(:project_sort_type => '0', :project_type => project_type, :school_id => school_id)))
      content << content_tag('li', link_to(l(:label_sort_by_active), course_path(:project_sort_type => '1', :project_type => project_type, :school_id => school_id), :class=>"selected"), :class=>"selected")
      # content << content_tag('li', link_to(l(:label_sort_by_influence), course_path(:project_sort_type => '2', :project_type => project_type)))
      content << content_tag('li', link_to(l(:label_sort_by_activity), course_path(:project_sort_type => '3', :project_type => project_type, :school_id => school_id)))

    when 2
      content << content_tag('li', link_to(l(:label_sort_by_time), course_path(:project_sort_type => '0', :project_type => project_type, :school_id => school_id)))
      content << content_tag('li', link_to(l(:label_sort_by_active), course_path(:project_sort_type => '1', :project_type => project_type, :school_id => school_id)))
      # content << content_tag('li', link_to(l(:label_sort_by_influence), course_path(:project_sort_type => '2', :project_type => project_type), :class=>"selected"), :class=>"selected")
      content << content_tag('li', link_to(l(:label_sort_by_activity), course_path(:project_sort_type => '3', :project_type => project_type, :school_id => school_id)))

    #gcm
    when 3
      content << content_tag('li', link_to(l(:label_sort_by_time), course_path(:project_sort_type => '0', :project_type => project_type, :school_id => school_id)))
      content << content_tag('li', link_to(l(:label_sort_by_active), course_path(:project_sort_type => '1', :project_type => project_type, :school_id => school_id)))
      # content << content_tag('li', link_to(l(:label_sort_by_influence), course_path(:project_sort_type => '2', :project_type => project_type)))
      content << content_tag('li', link_to(l(:label_sort_by_activity), course_path(:project_sort_type => '3', :project_type => project_type, :school_id => school_id), :class=>"selected"), :class=>"selected")
    end
    #gcmend
    
    content = content_tag('ul', content)
    content_tag('div', content, :class => "tabs")
  end
  # end
  
  def sort_project(state, project_type)
    content = ''.html_safe
    case state
    when 0

      content << content_tag('li', link_to(l(:label_sort_by_active), projects_path(:project_sort_type => '1', :project_type => project_type)))
      content << content_tag('li', link_to(l(:label_sort_by_influence), projects_path(:project_sort_type => '2', :project_type => project_type)))
      content << content_tag('li', link_to(l(:label_sort_by_time), projects_path(:project_sort_type => '0', :project_type => project_type), :class=>"selected"), :class=>"selected")
    when 1

      content << content_tag('li', link_to(l(:label_sort_by_active), projects_path(:project_sort_type => '1', :project_type => project_type), :class=>"selected"), :class=>"selected")
      content << content_tag('li', link_to(l(:label_sort_by_influence), projects_path(:project_sort_type => '2', :project_type => project_type)))
      content << content_tag('li', link_to(l(:label_sort_by_time), projects_path(:project_sort_type => '0', :project_type => project_type)))
    when 2
      content << content_tag('li', link_to(l(:label_sort_by_active), projects_path(:project_sort_type => '1', :project_type => project_type)))
      content << content_tag('li', link_to(l(:label_sort_by_influence), projects_path(:project_sort_type => '2', :project_type => project_type), :class=>"selected"), :class=>"selected")
      content << content_tag('li', link_to(l(:label_sort_by_time), projects_path(:project_sort_type => '0', :project_type => project_type)))
    end
    content = content_tag('ul', content)    
    content_tag('div', content, :class => "tabs")   
  end
  
   # def sort_course(state, project_type)
    # content = ''.html_safe
    # case state
    # when 0
#       
      # content << content_tag('li', link_to(l(:label_sort_by_active), course_path(:project_sort_type => '1', :project_type => project_type)))
      # content << content_tag('li', link_to(l(:label_sort_by_influence), course_path(:project_sort_type => '2', :project_type => project_type)))
      # content << content_tag('li', link_to(l(:label_sort_by_time), course_path(:project_sort_type => '0', :project_type => project_type), :class=>"selected"), :class=>"selected")
    # when 1
# 
      # content << content_tag('li', link_to(l(:label_sort_by_active), course_path(:project_sort_type => '1', :project_type => project_type), :class=>"selected"), :class=>"selected")
      # content << content_tag('li', link_to(l(:label_sort_by_influence), course_path(:project_sort_type => '2', :project_type => project_type)))
      # content << content_tag('li', link_to(l(:label_sort_by_time), course_path(:project_sort_type => '0', :project_type => project_type)))
    # when 2
      # content << content_tag('li', link_to(l(:label_sort_by_active), course_path(:project_sort_type => '1', :project_type => project_type)))
      # content << content_tag('li', link_to(l(:label_sort_by_influence), course_path(:project_sort_type => '2', :project_type => project_type), :class=>"selected"), :class=>"selected")
      # content << content_tag('li', link_to(l(:label_sort_by_time), course_path(:project_sort_type => '0', :project_type => project_type)))
    # end
    # content = content_tag('ul', content)
    # content_tag('div', content, :class => "tabs")
  # end

  
  # Added by young
  def course_settings_tabs
    tabs = [{:name => 'info', :action => :edit_project, :partial => 'projects/edit', :label => :label_information_plural, :course=>'1'},
            #{:name => 'boards', :action => :manage_boards, :partial => 'projects/settings/boards', :label => :label_board_plural, :project_type => 1},
            # {:name => 'repositories', :action => :manage_repository, :partial => 'projects/settings/repositories', :label => :label_repository_plural},
            {:name => 'members', :action => :manage_members, :partial => 'projects/settings/members', :label => :label_member_plural}
            ]
    tabs.select {|tab| User.current.allowed_to?(tab[:action], @project)}
  end
  # Ended by young




  def parent_project_select_tag(project)
    selected = project.parent
    # retrieve the requested parent project
    parent_id = (params[:project] && params[:project][:parent_id]) || params[:parent_id]
    if parent_id
      selected = (parent_id.blank? ? nil : Project.find(parent_id))
    end

    options = ''
    options << "<option value=''></option>" if project.allowed_parents.include?(nil)
    options << project_tree_options_for_select(project.allowed_parents.compact, :selected => selected)
    content_tag('select', options.html_safe, :name => 'project[parent_id]', :id => 'project_parent_id')
  end

  # Renders the projects index
  def render_project_hierarchy(projects)
    render_project_nested_lists(projects) do |project|
      #Modified by young
        if project.try(:project_type) == Project::ProjectType_course
          # modified by longjun
          # never use unless and else
          # unless project.is_public == 1
          if project.is_public != 1
            s = "<span class='private_project'>#{l(:label_private)}</span>".html_safe
          else
            s = "".html_safe
          end
          # end longjun
          # modified by Longjun
          s += link_to_project(project, {},
                               :class => "#{project.css_classes} #{User.current.member_of?(project) ? 'my-project' : nil}").html_safe
          # end longjun
        else
          # modified by longjun
          # unless project.is_public
          if !project.is_public
          # end longjun
            s = "<span class='private_project'>#{l(:label_private)}</span>".html_safe
          else
            s = "".html_safe
          end
          # modified by longjun
          s += link_to_project(project, {},
                               :class => "#{project.css_classes} #{User.current.member_of?(project) ? 'my-project' : nil}")
          # end longjun
        end
      #Ended by young
      if project.description.present?
        #Delete by nie.
        # s << content_tag('td', textilizable(project.short_description, :project => project), :class => 'wiki description')
      end
      s
    end
  end

  # Returns a set of options for a select field, grouped by project.
  def version_options_for_select(versions, selected=nil)
    grouped = Hash.new {|h,k| h[k] = []}
    versions.each do |version|
      grouped[version.project.name] << [version.name, version.id]
    end

    if grouped.keys.size > 1
      grouped_options_for_select(grouped, selected && selected.id)
    else
      options_for_select((grouped.values.first || []), selected && selected.id)
    end
  end

  def format_version_sharing(sharing)
    sharing = 'none' unless Version::VERSION_SHARINGS.include?(sharing)
    l("label_version_sharing_#{sharing}")
  end

  # this method is used to get all projects that tagged one tag
  # added by william
  def get_projects_by_tag(tag_name)
    Project.tagged_with(tag_name).order('updated_on desc')
  end
  
  # added by fq
  def homework_type_option
    type = []
    option1 = []
    option2 = []
    option1 << l(:label_task_submit_form_accessory)
    option1 << 1
    option2 << l(:label_task_submit_form_project)
    option2 << 2
    type << option1
    type << option2
  end

  #是否启动互评下拉框
  def is_evaluation_option
    type = []
    option1 = []
    option2 = []
    option1 << l(:lable_start_mutual_evaluation)
    option1 << 1
    option2 << l(:lable_close_mutual_evaluation)
    option2 << 2
    type << option1
    type << option2
  end

  # 用来判断用户是否是项目的管理员
  # added by william
  def is_manager?(user_id,project_id)
    @result = false
    @user_id = ProjectInfo.find_by_project_id(project_id)

      # modified by longjun
      # if @user_id == user.id
      #   @result = true
      # end

    @result = true if @user_id = user.id
    # end longjun
    return @result
  end

  # 将动态中类型转换为可读的字符串
  def eventToLanguage event_type
    case event_type
    when "issue-note"
      l :label_issue
    when "issue"
      l :label_issue
    when "attachment"
      l :label_attachment
    when "news"
      l :label_news 
    else
      ""     
    end
  end
  
  def eventToLanguageCourse event_type, project
    case event_type
    when "issue-note"
      l :label_issue
    when "issue"
      l :label_issue
    when "attachment"
      l :label_attachment
    when "news"
      project.project_type == 1 ? (l :label_notification) : (l :label_news)
    else
      ""     
    end
  end

  def rolesToLanguage rolesArray
    rolesArray = ([] << rolesArray) unless rolesArray.is_a?(Array)
    rolesArray.map{ |roleName|
      case roleName.to_sym
      when :Manager
        l :default_role_manager
      when :Developer
        l :default_role_developer
      when :Reporter
        l :default_role_reporter
      else
        'Unkown'
      end
    }
  end

  def sort_project_by_hot
    return sort_project_by_hot_rails
    @projects_status = ProjectStatus.visible.where("project_statuses.project_type <> ? or project_statuses.project_type is null", 1)
    @projects_status = @projects_status.reorder('grade').all.reverse
    @projects = []
    @projects_status.each do |obj| 
      break if(@projects_status[10] == obj)
      @projects << Project.visible.find_by_id("#{obj.project_id}")#where('id=:id', id: obj.project_id)
    end
    @projects
  rescue NoMethodError => e
    logger.error "Logger.Error [ProjectsHelper] ===> #sort_project_by_hot, NoMethodError: #{e}"
    []
  end

  def sort_project_by_hot_rails
    # @projects_status = ProjectStatus.visible.where("project_statuses.project_type <> ? or project_statuses.project_type is null", 1)
    # @projects_status = @projects_status.reorder('grade').all.reverse
    # Project.joins(@projects_status).limit(10)
    limit = 10
    #Project.find_by_sql("SELECT * FROM projects RIGHT OUTER JOIN (SELECT * FROM project_statuses ORDER BY  grade DESC LIMIT #{limit} ) AS t ON projects.id = t.project_id ")
    Project.find_by_sql("
      SELECT p.id, p.name, p.description, p.identifier, t.project_id 
        FROM projects AS p RIGHT OUTER JOIN (
          SELECT project_id,grade FROM project_statuses 
            WHERE project_type = 0 ORDER BY  grade DESC LIMIT #{limit} ) AS t ON p.id = t.project_id ")
  end
 

  # 判断课程是否结束,快别用，这个定日子的方法有问题
  def course_timeout? project
    return true if (project.nil? && project.course_extra.nil?)
    courses_year = project.course_extra.time
    current_year = Time.now.year
    if courses_year >= current_year
      return false
    elsif (courses_year < current_year) && (Time.now.month < 3)
      return false
    else
      return true
    end
  end

  def find_project_repository project
    unless project.repositories.nil?
      project.repositories.each do |repository|
        repository.fetch_changesets if Setting.autofetch_changesets?
      end
    end
  end
end
